#ifndef CHARSETS_H
#define CHARSETS_H

#include <unistd.h>
#include <wchar.h>

typedef wchar_t ucs4_t;
typedef wchar_t* conv_t;

/* Return code if invalid. (xxx_mbtowc) */
#define RET_ILSEQ      -1
/* Return code if only a shift sequence of n bytes was read. (xxx_mbtowc) */
#define RET_TOOFEW(n)  (-2-(n))
/* Return code if invalid. (xxx_wctomb) */
#define RET_ILUNI      -1
/* Return code if output buffer is too small. (xxx_wctomb, xxx_reset) */
#define RET_TOOSMALL   -2

#define CODEPAGE_UTF(a) (a+2000)
#define CODEPAGE_EUCKR 2101

typedef int (*_mbtowc) (conv_t conv, ucs4_t *pwc, const unsigned char *s, int n);
typedef int (*_wctomb) (conv_t conv, unsigned char *r, ucs4_t wc, int n);

#ifdef __cplusplus
extern "C" 
{
#endif

_mbtowc get_mbtowc(int cp, int def);
_wctomb get_wctomb(int cp, int def);

size_t iconv(int from, int to, const char **inbuf, size_t *inbytesleft, char **outbuf, size_t *outbytesleft);


#ifdef __cplusplus
}
#endif

#endif
